/********************************************************************************
    extractts - extract a channel from a transport stream
 ********************************************************************************
    LibVideoCoding - video coding library
    Copyright (C) 2002  Dirk Farin

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************/

#include <libvideocoding/fileio/inputstream_istr.hh>
#include <libvideocoding/mpeg2/syntax/pessource.hh>
#include <libvideocoding/mpeg2/syntax/demux.hh>

#include <unistd.h>
#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;
using namespace videocoding;


int main()
{
  int pid = 110;

  try
    {
      InputStream_IStream istr;
      istr.SetIStream(cin);

      MP2_Transport_Packet ts_pck;

      while (!istr.IsEOF())
	{
	  try
	    {
	      ts_pck.Read(istr);
	      //cerr << ts_pck << endl;
	    }
	  catch (const Excpt_Base& e)
	    {
	      MessageDisplay::Show(e);
	    }

	  if (ts_pck.PID == pid)
	    for (int i=0;i<ts_pck.payload_length;i++)
	      cout << (ts_pck.payload[i]);
	}
    }
  catch (const Excpt_Base& e)
    {
      MessageDisplay::Show(e);
    }

  return 0;
}
