/********************************************************************************
    streamtype - guess input stream type
 ********************************************************************************
    LibVideoCoding - video coding library
    Copyright (C) 2002  Dirk Farin

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************/

#include <libvideocoding/fileio/inputstream_istr.hh>
#include <libvideocoding/mpeg2/syntax/system.hh>

#include <iostream>
using namespace std;
using namespace videocoding;

int main(int argc, char** argv)
{
  InputStream_IStream istr;
  istr.SetIStream(cin);

  MP2_Stream_Type type = DetermineStreamType(istr);

  switch (type)
    {
    case MPEG_Video_Stream:     cout << "video stream\n"; break;
    case MPEG_Audio_Stream:     cout << "audio stream\n"; break;
    case MPEG_Program_Stream:   cout << "program stream\n"; break;
    case MPEG_Transport_Stream: cout << "transport stream\n"; break;
    case MPEG_Unknown_Stream:   cout << "unknown stream\n"; break;
    }

  return 0;
}
