/********************************************************************************
  $Header: /home/farin/cvs/libvideocoding/libvideocoding/dct/dct.hh,v 1.4 2002/05/09 22:00:31 farin Exp $

    8x8-DCT transformation classes.
 ********************************************************************************
    Copyright (C) 2000 Dirk Farin (see the README for complete list of authors)

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef LIBVIDEOCODING_DCT_DCT_HH
#define LIBVIDEOCODING_DCT_DCT_HH

#include <libvideogfx/types.hh>
#include <libvideocoding/datatypes/dct.hh>

namespace videocoding {

  template <class InputType> class FDCTBlk8x8
  {
  public:
    virtual ~FDCTBlk8x8() { }

    virtual void CalcFDCT(DCTBlock_8x8&, const InputType* in,int in_stride) = 0;
    virtual const char* Name() const = 0;
  };


  template <class OutputType> class IDCTBlk8x8
  {
  public:
    IDCTBlk8x8() { }
    virtual ~IDCTBlk8x8() { }

    virtual void CalcIDCT(OutputType* out,int out_stride, const DCTBlock_8x8&,bool add=false) = 0;
    virtual const char* Name() const = 0;

  protected:
  };


  FDCTBlk8x8<Pixel>* GetFDCT8x8_8 (bool accurate=true);
  FDCTBlk8x8<int16>* GetFDCT8x8_16(bool accurate=true);
  IDCTBlk8x8<Pixel>* GetIDCT8x8_8 (bool ieee_compliant=true);
  IDCTBlk8x8<int16>* GetIDCT8x8_16(bool ieee_compliant=true);
}

#endif
