/********************************************************************************
  $Header: /home/farin/cvs/libvideocoding/libvideocoding/motioncomp/motioncomp_scalar.hh,v 1.4 2002/05/02 17:24:56 farin Exp $

    Low-level motion compensation routines (scalar C code)
 ********************************************************************************
    Copyright (C) 2000 Dirk Farin (see the README for complete list of authors)

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef LIBVIDEOCODING_MOTIONCOMP_MOTIONCOMP_SCALAR_HH
#define LIBVIDEOCODING_MOTIONCOMP_MOTIONCOMP_SCALAR_HH

#include <libvideocoding/motioncomp/motioncomp.hh>

namespace videocoding {

  class MotionCompensation_Scalar : public MotionCompensation
  {
  public:
    MotionCompensation_Scalar(int blkw,bool avg);

    void Compensate(Pixel* dest,int dest_stride,
		    const Bitmap<Pixel>& ref,
		    int ref_x0,int ref_y0,
		    const MotionVector& mv,int blkh);

    const char* AskName() const { return "scalar, half-pel resolution"; }

  private:
    int  d_blkw;
    bool d_avg;
  };

}

#endif
